log4cplus::helpers::SharedObjectPtr< T > Class Template Reference

`#include <pointer.h>`

Inheritance diagram for log4cplus::helpers::SharedObjectPtr< T >:
[legend]

## Public Types

typedef T *(SharedObjectPtr::* | unspec_bool_type) () const

## Public Member Functions

| SharedObjectPtr (T *realPtr=0) LOG4CPLUS_NOEXCEPT
| SharedObjectPtr (const SharedObjectPtr &rhs) LOG4CPLUS_NOEXCEPT
| SharedObjectPtr (SharedObjectPtr &&rhs) LOG4CPLUS_NOEXCEPT
SharedObjectPtr & | operator= (SharedObjectPtr &&rhs) LOG4CPLUS_NOEXCEPT
| ~SharedObjectPtr ()
bool | operator== (const SharedObjectPtr &rhs) const
bool | operator!= (const SharedObjectPtr &rhs) const
bool | operator== (const T *rhs) const
bool | operator!= (const T *rhs) const
T * | operator-> () const
T & | operator* () const
SharedObjectPtr & | operator= (const SharedObjectPtr &rhs)
SharedObjectPtr & | operator= (T *rhs)
T * | get () const
void | swap (SharedObjectPtr &other) LOG4CPLUS_NOEXCEPT
| operator unspec_bool_type () const
bool | operator! () const

## Detailed Description

template<class T>
class log4cplus::helpers::SharedObjectPtr< T >

Definition at line 100 of file pointer.h.

## Member Typedef Documentation

## unspec_bool_type

template<class T>

typedef T *(SharedObjectPtr::* log4cplus::helpers::SharedObjectPtr< T >::unspec_bool_type) () const

Definition at line 165 of file pointer.h.

## Constructor & Destructor Documentation

## SharedObjectPtr() [1/3]

template<class T>

log4cplus::helpers::SharedObjectPtr< T >::SharedObjectPtr | ( | T * | realPtr = 0 | ) |

inline explicit

Definition at line 105 of file pointer.h.

Referenced by log4cplus::helpers::SharedObjectPtr< Appender >::operator=().

## SharedObjectPtr() [2/3]

template<class T>

log4cplus::helpers::SharedObjectPtr< T >::SharedObjectPtr | ( | const SharedObjectPtr< T > & | rhs | ) |

inline

Definition at line 111 of file pointer.h.

## SharedObjectPtr() [3/3]

template<class T>

log4cplus::helpers::SharedObjectPtr< T >::SharedObjectPtr | ( | SharedObjectPtr< T > && | rhs | ) |

inline

Definition at line 117 of file pointer.h.

## ~SharedObjectPtr()

template<class T>

log4cplus::helpers::SharedObjectPtr< T >::~SharedObjectPtr | ( |  | ) |

inline

Definition at line 130 of file pointer.h.

## Member Function Documentation

## get()

template<class T>

T * log4cplus::helpers::SharedObjectPtr< T >::get | ( |  | ) | const

inline

Definition at line 158 of file pointer.h.

Referenced by log4cplus::helpers::SharedObjectPtr< Appender >::operator unspec_bool_type().

## operator unspec_bool_type()

template<class T>

log4cplus::helpers::SharedObjectPtr< T >::operator unspec_bool_type | ( |  | ) | const

inline

Definition at line 166 of file pointer.h.

## operator!()

template<class T>

bool log4cplus::helpers::SharedObjectPtr< T >::operator! | ( |  | ) | const

inline

Definition at line 171 of file pointer.h.

## operator!=() [1/2]

template<class T>

bool log4cplus::helpers::SharedObjectPtr< T >::operator!= | ( | const SharedObjectPtr< T > & | rhs | ) | const

inline

Definition at line 139 of file pointer.h.

## operator!=() [2/2]

template<class T>

bool log4cplus::helpers::SharedObjectPtr< T >::operator!= | ( | const T * | rhs | ) | const

inline

Definition at line 142 of file pointer.h.

## operator*()

template<class T>

T & log4cplus::helpers::SharedObjectPtr< T >::operator* | ( |  | ) | const

inline

Definition at line 144 of file pointer.h.

## operator->()

template<class T>

T * log4cplus::helpers::SharedObjectPtr< T >::operator-> | ( |  | ) | const

inline

Definition at line 143 of file pointer.h.

## operator=() [1/3]

template<class T>

SharedObjectPtr & log4cplus::helpers::SharedObjectPtr< T >::operator= | ( | const SharedObjectPtr< T > & | rhs | ) |

inline

Definition at line 146 of file pointer.h.

## operator=() [2/3]

template<class T>

SharedObjectPtr & log4cplus::helpers::SharedObjectPtr< T >::operator= | ( | SharedObjectPtr< T > && | rhs | ) |

inline

Definition at line 123 of file pointer.h.

Referenced by log4cplus::helpers::SharedObjectPtr< Appender >::operator=().

## operator=() [3/3]

template<class T>

SharedObjectPtr & log4cplus::helpers::SharedObjectPtr< T >::operator= | ( | T * | rhs | ) |

inline

Definition at line 151 of file pointer.h.

## operator==() [1/2]

template<class T>

bool log4cplus::helpers::SharedObjectPtr< T >::operator== | ( | const SharedObjectPtr< T > & | rhs | ) | const

inline

Definition at line 137 of file pointer.h.

## operator==() [2/2]

template<class T>

bool log4cplus::helpers::SharedObjectPtr< T >::operator== | ( | const T * | rhs | ) | const

inline

Definition at line 141 of file pointer.h.

## swap()

template<class T>

void log4cplus::helpers::SharedObjectPtr< T >::swap | ( | SharedObjectPtr< T > & | other | ) |

inline

Definition at line 160 of file pointer.h.

Referenced by log4cplus::helpers::SharedObjectPtr< Appender >::operator=().

The documentation for this class was generated from the following file:

- pointer.h